{% extends "crud.html" %}


{% block sub_head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datepicker.css",
        "css/plugins/bootstrap-datepicker.min.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% assets
        filters="rjsmin",
        output="compressed/datepicker.js",
        "js/plugins/bootstrap-datepicker.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <style>
        .gray-bg {background-color: #f5f5f5}
    </style>
{% endblock %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block datatable_filters %}
    <div class="col-12 offset-md-5 col-md-3">
        <div class="form-group">
            <select class="form-control" data-datatable-filter="7">
                <option value="">All Validity</option>
                <option value="true">Valid Only</option>
                <option value="false">Invalid Only</option>
            </select>
        </div>
    </div>
{% endblock %}


{% block add_form %}
<div class="row">
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "client"|normalize|title }}*</label>
                    <select name="client" class="form-control" data-ajax-select-target="/api/v1/clients/all?fields=name,business_type" data-ajax-select-value="_id" data-ajax-select-label="name,business_type" required placeholder="-- Select Client --">
                        <option value="">-- Select Client --</option>
                    </select>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "formula_no"|normalize|title }}*</label>
                    <input type="text" name="formula_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label><b>{{ "product_code"|normalize|title }}*</b></label>
                    <input type="text" name="product_code" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "description"|normalize|title }}*</label>
                    <textarea name="description" class="form-control" rows="2" required></textarea>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "variant"|normalize|title }}*</label>
                    <textarea name="variant" class="form-control" rows="2" required></textarea>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "default_unit"|normalize|title }}*</label>
                    <select name="default_unit" class="form-control" required>
                        <option value="">-- Select Default Unit --</option>
                        {% for option in units %}
                            <option value="{{ option.decode("utf-8") }}">{{ option.decode("utf-8") }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label><b>{{ "standard_packing_per_piece"|normalize|title }}*</b></label>
                    <input type="number" name="standard_packing_per_piece" class="form-control" min="1" step="any" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label><b>{{ "standard_specific_gravity"|normalize|title }}*</b></label>
                    <input type="number" name="standard_specific_gravity" class="form-control" step="any" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "date_original_issue"|normalize|title }}*</label>
                    <input type="text" name="date_original_issue" class="form-control datepicker" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "revision_no"|normalize|title }}*</label>
                    <input type="number" name="revision_no" class="form-control" min="1" step="1" value="1" data-default-value="1" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "revision_reason"|normalize|title }}</label>
                    <textarea name="revision_reason" class="form-control" rows="2"></textarea>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group formula">
                    <label>{{ "valid"|normalize|title }}</label>
                    <input type="text" class="form-control" readonly />
                    <input type="hidden" name="valid" class="form-control" />
                </div>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-12 col-md-6" data-raw-material-container>
        <h5>Raw Materials</h5>
        <div class="row">
            <div class="col-12 col-md-12">
                <a class="btn btn-warning btn-sm btn-block" href="javascript:;" data-raw-material-toggle="add"> <i class="fa fa-plus"></i> Add Raw Material</a>
            </div>
        </div>
        <h5><small class="float-right">Total: <b>0</b></small></h5>
    </div>
    <div class="col-12 col-md-6" data-packaging-material-container>
        <h5>Packaging Materials</h5>
        <div class="row">
            <div class="col-12 col-md-12">
                <a class="btn btn-warning btn-sm btn-block" href="javascript:;" data-packaging-material-toggle="add"> <i class="fa fa-plus"></i> Add Packaging Material</a>
            </div>
        </div>
        <h5><small class="float-right invisible">Total: <b>0</b></small></h5>
    </div>
</div>
<span><small>Percentages must total to 100.00 to be valid</small></span>
{% endblock %}


{% block empty_spiel %}
    Add Formulas for final products
    <br />
    details include breakdown of raw materials
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'product_code',
        searchable: true,
        orderable: true,
        render: function(data) {
            return '<a href="javascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> #{0}</a>'.format(data);
        }
    },
    {
        data: 'client',
        className: 'd-none d-sm-none d-md-none d-lg-table-cell',
        searchable: false,
        orderable: true
    },
    {
        data: 'formula_no',
        searchable: true,
        orderable: true
    },
    {
        data: 'description',
        searchable: true,
        orderable: true
    },
    {
        data: 'variant',
        className: 'd-none d-sm-none d-md-table-cell',
        searchable: true,
        orderable: true
    },
    {
        data: 'date_last_modified',
        searchable: false,
        orderable: true,
    },
    {
        data: 'valid',
        searchable: true,
        orderable: true,
        render: function(data) {
            return (data === true) ? 'Valid' : 'Invalid';
        }
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data) {
            return '<a href="javascript:;" class="btn btn-warning btn-sm btn-block" data-formula-toggle="duplicate" data-duplicate-target="{0}"><i class="fa fa-copy fa-fw"></i> Duplicate</a>'.format(data);
        }
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data) {
            return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i> Delete</a>'.format(data);
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    var raw_materials_valid = false, packaging_materials_valid = false;
    function change_validity(crud) {
        is_valid = raw_materials_valid && packaging_materials_valid;
        $('[data-crud="{0}"] .form-group.formula input[type="text"]'.format(crud)).val((is_valid) ? 'True' : 'False');
        $('[data-crud="{0}"] .form-group.formula input[type="hidden"]'.format(crud)).val((is_valid) ? true : false);
    }

    function compute_total(crud, target) {
        let total = 0;
        let has_item = false;
        $.each($('[data-crud={0}] [data-{1}-container] [name="{1}s-quantity"]'.format(crud, target)), function(i, v) {
            has_item = true;
            total += parseFloat($(v).val());
            total = Math.round(total * 10000) / 10000;
        });
        $('[data-crud={0}] [data-{1}-container] > h5 > small > b'.format(crud, target)).html(total);
        if (target == 'raw-material') {
            return (total == 100.00) ? true : false;
        }
        else if (target == 'packaging-material') {
            return has_item;
        }
        return false;
    }

    $dom.document.on('click', '[data-raw-material-toggle="add"]', function() {
        $c = $(this).closest('[data-raw-material-container]');
        color = ($c.find('.row').length%2) ? 'gray-bg' : '';
        $c.find('.row:last').after(`
            <div class="row {0}" data-form-dynamic>
                <div class="col-4 offset-8 col-md-3 offset-md-9">
                    <a href="javascript:;" class="btn btn-secondary btn-sm btn-block" data-raw-material-toggle="delete"> Delete Item</a>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Item Code*</label>
                        <select name="raw-materials-item_code" class="form-control" data-ajax-select-target="/api/v1/raw_materials/all?category=raw_material&fields=description,item_code" data-ajax-select-value="_id" data-ajax-select-label="item_code,description" required placeholder="-- Select Item Code --">
                            <option value="">-- Select Item Code --</option>
                        </select>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Percentage Quantity*</label>
                        <input type="number" name="raw-materials-quantity" class="form-control" min="0.000001" max="100" step="0.000001" required />
                    </div>
                </div>
            </div>
        `.format(
            color
        ));
        $c.find('.row:last [data-ajax-select-target]').ajaxDropdown();
    });

    $dom.document.on('click', '[data-raw-material-toggle="delete"]', function() {
        $c = $(this).closest('[data-raw-material-container]');
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Delete Raw Material?',
            text: 'Unsaved information will be removed',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $self.closest('.row[data-form-dynamic]').remove();
                raw_materials_valid =  compute_total($c.closest('[data-crud]').attr('data-crud'), 'raw-material');
                change_validity($c.closest('[data-crud]').attr('data-crud'));
                $.each($c.find('.row[data-form-dynamic]'), function(i, v) {
                    $(v).removeClass('gray-bg');
                    if (i % 2 == 0) {
                        $(v).addClass('gray-bg');
                    }
                });
            }
        });
    });

    $dom.document.on('click', '[data-packaging-material-toggle="add"]', function() {
        $c = $(this).closest('[data-packaging-material-container]');
        color = ($c.find('.row').length%2) ? 'gray-bg' : '';
        $c.find('.row:last').after(`
            <div class="row {0}" data-form-dynamic>
                <div class="col-4 offset-8 col-md-3 offset-md-9">
                    <a href="javascript:;" class="btn btn-secondary btn-sm btn-block" data-packaging-material-toggle="delete"> Delete Item</a>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Item Code*</label>
                        <select name="packaging-materials-item_code" class="form-control" data-ajax-select-target="/api/v1/raw_materials/all?category=packaging_material&fields=description,item_code" data-ajax-select-value="_id" data-ajax-select-label="item_code,description" required placeholder="-- Select Item Code --">
                            <option value="">-- Select Item Code --</option>
                        </select>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Piece(s)*</label>
                        <input type="number" name="packaging-materials-quantity" class="form-control" min="0.000001" max="100" step="0.000001" required />
                    </div>
                </div>
            </div>
        `.format(
            color
        ));
        $c.find('.row:last [data-ajax-select-target]').ajaxDropdown();
    });

    $dom.document.on('click', '[data-packaging-material-toggle="delete"]', function() {
        $c = $(this).closest('[data-packaging-material-container]');
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Delete Raw Material?',
            text: 'Unsaved information will be removed',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $self.closest('.row[data-form-dynamic]').remove();
                packaging_materials_valid =  compute_total($c.closest('[data-crud]').attr('data-crud'), 'packaging-material');
                change_validity($c.closest('[data-crud]').attr('data-crud'));
                $.each($c.find('.row[data-form-dynamic]'), function(i, v) {
                    $(v).removeClass('gray-bg');
                    if (i % 2 == 0) {
                        $(v).addClass('gray-bg');
                    }
                });
            }
        });
    });

    $dom.document.on('keyup mouseup input', '[data-raw-material-container] [name="raw-materials-quantity"]', function() {
        if ($(this).val() !== '') {
            raw_materials_valid = compute_total($(this).closest('[data-crud]').attr('data-crud'), 'raw-material');
            change_validity($(this).closest('[data-crud]').attr('data-crud'));
        }
    });

    $dom.document.on('keyup mouseup input', '[data-packaging-material-container] [name="packaging-materials-quantity"]', function() {
        if ($(this).val() !== '') {
            packaging_materials_valid =  compute_total($(this).closest('[data-crud]').attr('data-crud'), 'packaging-material');
            change_validity($(this).closest('[data-crud]').attr('data-crud'));
        }
    });

    $dom.document.on('click', '[data-crud-toggle="add"]', function() {
        raw_materials_valid = compute_total('add', 'raw-material');
        packaging_materials_valid =  compute_total('add', 'packaging-material');
        change_validity('add');
    });

    $dom.document.on('click', '[data-formula-toggle="duplicate"]', function() {
        $self = $(this);
        Swal.mixin({
            confirmButtonText: 'Next &rarr;',
            showCancelButton: true,
            focusCancel: true,
            progressSteps: ['1', '2', '3']
        }).queue([
            {
                title: 'Input new Formula No.',
                input: 'text',
                inputValidator: (value) => {
                    if (!value) {
                        return 'Empty Formula No.';
                    } else {
                        if (value.length > 32) {
                            return 'Formula No. must not be longer than 32 characters';
                        }

                        return;
                    }
                }
            },
            {
                title: 'Input new Product Code',
                input: 'text',
                inputValidator: (value) => {
                    if (!value) {
                        return 'Empty Product Code';
                    } else {
                        if (value.length > 32) {
                            return 'Product Code must not be longer than 32 characters';
                        }

                        return;
                    }
                }
            },
            {
                title: 'Input new Variant',
                input: 'text',
                inputValidator: (value) => {
                    if (!value) {
                        return 'Empty Variant';
                    } else {
                        return;
                    }
                }
            },
        ]).then((result) => {
            if (result.value) {
                $.post('{{ url_for(".duplicate", _id="placeholder") }}'.replace('placeholder', $self.attr('data-duplicate-target')), {'formula_no': result.value[0].toUpperCase(), 'product_code': result.value[1].toUpperCase(), 'variant': result.value[2]}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('Duplicated Successfully', '', 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                    $dom.datatables.records.reload('duplicate formula');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.find('[name="date_original_issue"].datepicker').datepicker();
{# </script> #}
{% endblock %}
